﻿package {
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	
	public class TitleBar extends Sprite {
				
		public function TitleBar() {
			// 画面の固定
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			// ボタンの設定
			_closeBtn.addEventListener(MouseEvent.CLICK, close);
			_minimizeBtn.addEventListener(MouseEvent.CLICK, minimize);
			_maximizeBtn.addEventListener(MouseEvent.CLICK, maximize);
			_restoreBtn.addEventListener(MouseEvent.CLICK, restore);
			_restoreBtn.visible = false;
			_resizeCursor.addEventListener(MouseEvent.MOUSE_DOWN, resizeApp);
			
			// ヘッダーの設定
			_header.addEventListener(MouseEvent.MOUSE_DOWN, move);
			
			// リサイズ処理の設定
			stage.nativeWindow.addEventListener(NativeWindowBoundsEvent.RESIZE, adjust);
			stage.nativeWindow.minSize = new Point(300, 200);
		}
		
		private function restore(e:MouseEvent):void {
			stage.nativeWindow.restore();
			_restoreBtn.visible = false;
		}
		
		private function maximize(e:MouseEvent):void {
			stage.nativeWindow.maximize();
			_restoreBtn.visible = true;
		}
		
		private function minimize(e:MouseEvent):void {
			stage.nativeWindow.minimize();
		}
		
		private function resizeApp(e:MouseEvent):void {
			stage.nativeWindow.startResize(NativeWindowResize.BOTTOM_RIGHT);
		}
		
		private function adjust(e:NativeWindowBoundsEvent) {
			
			// ヘッダー、背景のリサイズ
			_header.width = e.afterBounds.width;
			_bg.width = e.afterBounds.width;
			_bg.height = e.afterBounds.height;
			
			// ボタンの位置設定の調整
			_minimizeBtn.x = e.afterBounds.width - 54;
			_maximizeBtn.x = _restoreBtn.x = e.afterBounds.width - 36;
			_closeBtn.x = e.afterBounds.width - 18;
			_resizeCursor.x = e.afterBounds.width - 17;
			_resizeCursor.y = e.afterBounds.height - 17;
		}
		
		private function close(evt:Event) {
			stage.nativeWindow.close();
		}
		
		private function move(evt:Event) {
			stage.nativeWindow.startMove();
		}
	}
}
