﻿package {

	import flash.desktop.*;
	import flash.display.*;
	import flash.events.*;
	import flash.filesystem.*;
	import flash.net.FileFilter;
	import flash.utils.ByteArray;
	import flash.geom.Matrix;
	
	//as3corelib (http://code.google.com/p/as3corelib/ よりダウンロード)
	import com.adobe.images.JPGEncoder;
	
	public class JPGThumbGen extends MovieClip {
		
		private var _file:File;
		private var _stream:FileStream;
		private var _ldr:Loader;

		public function JPGThumbGen() {
			this.gotoAndStop("select");
			init();
		}
		
		private function init():void {			
			_file = new File();
			_file.addEventListener(Event.SELECT, onSelected);
			_file.addEventListener(Event.CANCEL, onCancel);
			var _filter:FileFilter 
					= new FileFilter("画像ファイル(*.jpg)", "*.jpg;");
			try {
				// ファイル選択ダイアログの表示
				_file.browseForOpen("ファイルの選択", [_filter]);
			}catch (error:Error) {
				trace(error.message);
			}
		}
		
		private function onSelected(event:Event):void {
			_stream = new FileStream();
			_stream.addEventListener(IOErrorEvent.IO_ERROR, onIOError);
			_stream.addEventListener(Event.COMPLETE, onStreamComplete);
			_stream.openAsync(_file, FileMode.READ);
			
			//画面を変換中に変更
			gotoAndStop("convert");
		}

		private function onStreamComplete(event:Event):void {
			var byteArr:ByteArray = new ByteArray();
			_ldr = new Loader();
			_ldr.contentLoaderInfo.addEventListener(Event.COMPLETE,
													onLoadComplete);
			try {
				_stream.readBytes(byteArr, 0, _stream.bytesAvailable);
				_ldr.loadBytes(byteArr);
			} catch (error:Error) {
				quit();
			} finally {
				_stream.close();
			}
		}

		private function onLoadComplete(event:Event):void {
			// サムネイル画像の作成
			var w = 100 / _ldr.width;
			var h = 100 / _ldr.height;
			var ratio = (w < h)? w:h;
			var _matrix=new Matrix();
			_matrix.scale(ratio, ratio);
			var thumbImg:BitmapData = new BitmapData(
										 _ldr.width * ratio,
										 _ldr.height * ratio,
										 true, 0xFFFFFFFF)
			thumbImg.draw(_ldr, _matrix, null, null, null, true);
			
			//圧縮率80でBitmapDataをjpeg形式のByteArrayに保存
			var jpgEnc:JPGEncoder = new JPGEncoder(80);
			var jpgBytes:ByteArray = jpgEnc.encode(thumbImg);
			
			//ファイルの書き出し
			var newName:String
				= _file.name.substr(0, -4) + "_thumb.jpg"
			_stream.open(File.desktopDirectory.resolvePath(newName),
						 FileMode.WRITE);
			_stream.writeBytes(jpgBytes, 0, jpgBytes.length);
			_stream.close();
			
			// 完了画面に遷移
			gotoAndPlay("done");
		}
		
		private function onCancel(event:Event):void {
			//キャンセル時はAirを終了
			quit();
		}

		private function onIOError(event:IOErrorEvent):void {
			//エラー時はAirを終了
			quit();
		}
		
		public function quit():void{
			NativeApplication.nativeApplication.exit();
		}
	}
}
