﻿package{
	
	import flash.display.*;
	import flash.events.*;
	import flash.net.URLRequest;
	import flash.html.HTMLLoader;
	import flash.utils.Timer;
	
	import caurina.transitions.Tweener;
	
	public class BraBraBrowser extends Sprite{
		
		var _urlList:Array = ["http://level0.cuppy.co.jp/", "http://www.f-site.org/", "http://www.adobe.com/jp/devnet/",
							  "http://faces.jp/", "http://www.be-interactive.org/"];//記事URL保持配列
		var _currentHTML:SampleHTMLLoader;//HTMLローダ
		var _loading:MovieClip;//ローディング
		
		//コンストラクタ
		public function BraBraBrowser(){
			init();
		}
		
		//初期実行メソッド
		private function init(){
			showLoading();
			setStage();
			readNext();
		}
		
		//ステージ設定
		private function setStage():void{
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.addEventListener(Event.RESIZE, stageResizeHandler);
		}
		
		//ステージリサイズハンドラ
		private function stageResizeHandler(e:Event):void{
			if(_loading != null){
				_loading.x = stage.stageWidth/2;
				_loading.y = stage.stageHeight/2;
			}
			if(_currentHTML != null){
				_currentHTML.width = stage.stageWidth > 2880 ? 2880 : stage.stageWidth;
				_currentHTML.height = stage.stageHeight > 2880 ? 2880 : stage.stageHeight;
			}
		}
		
		//ローディング表示
		private function showLoading():void{
			_loading = new Loading();
			_loading.x = stage.stageWidth / 2;
			_loading.y = stage.stageHeight / 2;
			addChild(_loading);
		}
		
		//ローディングフェードアウト
		private function hideLoading():void{
			Tweener.addTween(_loading, {alpha:0, y:_loading.y - 5, time:0.5, transition:"easeoutcubic", onComplete:onLoadingHideHandler});
		}
		
		//ローディングフェードアウト完了
		private function onLoadingHideHandler():void{
			removeChild(_loading);
			_loading = null;
			addChildAt(_currentHTML, 0);
		}
		
		//次の記事へ
		private function readNext():void{
			var nextURL:String = _urlList.shift();
			_urlList.push(nextURL);
			loadHTML(nextURL);
		}
		
		//HTMLページロード
		private function loadHTML(url:String):void{
			
			// HTMLLoader を継承した SampleHTMLLoader クラスを生成
			var htmlLoader:SampleHTMLLoader = new SampleHTMLLoader();
			
			//HTMLLoaderのサイズを設定
			htmlLoader.width = 
						stage.stageWidth > 2880 ? 2880 : stage.stageWidth;
			htmlLoader.height =
						stage.stageHeight > 2880 ? 2880 : stage.stageHeight;
			
			//ロード完了イベントをリスン
			htmlLoader.addEventListener(Event.COMPLETE,
										loadHTMLCompleteHandler, false, 0, true);
			
			//リクエストを作成
			var req:URLRequest = new URLRequest(url);
			
			//ロードする
			htmlLoader.load(req);
		}
		
		//HTMLページロード完了
		private function loadHTMLCompleteHandler(e:Event):void{
			var beforeHTML:SampleHTMLLoader = _currentHTML;
			_currentHTML = e.target as SampleHTMLLoader;
			_currentHTML.addEventListener("scrollComplete", htmlScrollCompleteHandler, false, 0, true);
			_currentHTML.scrollToBottom();
			if(_loading != null){
				hideLoading();
			}else{
				addChildAt(_currentHTML, 0);
			}
			if(beforeHTML != null){
				beforeHTML.addEventListener("onHide", htmlHideCompleteHandler, false, 0, true);
				beforeHTML.fadeOut();
			}
		}
		
		//HTMLページスクロール完了
		private function htmlScrollCompleteHandler(e:Event):void{
			var htmlLoader:SampleHTMLLoader = e.target as SampleHTMLLoader;
			htmlLoader.removeEventListener("scrollComplete", htmlScrollCompleteHandler);
			readNext();
		}
		
		//HTMLページフェードアウト完了
		private function htmlHideCompleteHandler(e:Event):void{
			var htmlLoader:SampleHTMLLoader = e.target as SampleHTMLLoader;
			htmlLoader.destroy();
		}
	}
	
}