﻿package {
	
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.media.Sound;
	
	/**
	  * 時計機能
	  */
	public class Clock extends MovieClip {
		
		private var _sound:Sound;
		private var _second:Number;
		private var _minutes:Number;
		private var _hour:Number;
		private var _postLdr:URLLoader;
		private var _txtWord:String = "";
		
		/**
		  * コンストラクタ
		  */
		public function Clock() {
			this.addEventListener(Event.ENTER_FRAME, motion);
			_soundBtn.addEventListener(MouseEvent.CLICK, clickSoundBtn);
			_closeBtn.addEventListener(MouseEvent.CLICK, clickCloseBtn);
			_bg.addEventListener(MouseEvent.MOUSE_DOWN, windowMove);
		}
		
		/**
		  * パーツのドラッグ処理
		  */
		private function windowMove(event:MouseEvent):void {
			stage.nativeWindow.startMove();
		}
		
		/**
		  * 閉じるボタン処理
		  */
		public function clickCloseBtn(event:MouseEvent):void {
			 stage.nativeWindow.close();
		}
		
		/**
		  * 針の移動
		  */
		private function motion(evt:Event) {
			var date:Date = new Date();
			_second = date.getSeconds();
			_minutes = date.getMinutes();
			_hour = date.getHours();
			_second_hand.rotation = _second /60 * 360;
			_long_hand.rotation = (_minutes + _second / 60) / 60 * 360;
			_short_hand.rotation = (_hour + _minutes / 60) /12 * 360;
			var txtWord = _hour + "時" + _minutes + "分になりました。";
			
			// 毎時間、時間を報告する
			// 連投防止、同じテキストを連続して報告しないようにする
			if (_second == 0 && _minutes == 0 && _txtWord != txtWord) {
				_txtWord = txtWord;
				loadSound(_txtWord);
			}
		}
		
		/**
		  * 音声ボタンクリック処理
		  */
		private function clickSoundBtn(evt:Event) {
			loadSound("ただいまの時間は" + _hour + "時" + _minutes + "分です。");
		}
		
		/**
		  * TEXT2VOICE へ要求の送信
		  */
		private function loadSound(word:String) {
			var infoObj:URLVariables = new URLVariables();
			infoObj.text = word;
			var urlReq:URLRequest = new URLRequest("http://api.satoru.net/text2voice/");
			urlReq.method = URLRequestMethod.GET;
			urlReq.data = infoObj;
			_postLdr = new URLLoader(urlReq);
			_postLdr.addEventListener(Event.COMPLETE, loadedSoundInfo);
			_postLdr.addEventListener(IOErrorEvent.IO_ERROR, function(evt:Event) {trace("err");}, false, 0, true);
		}
		
		/**
		  * 音声の再生
		  */
		private function loadedSoundInfo(evt:Event) {
			// TEXT2VOICE から返された URL にある mp3 を再生する
			var sound:Sound = new Sound(new URLRequest(_postLdr.data));
			sound.addEventListener(IOErrorEvent.IO_ERROR, function(evt:Event) {trace("err");}, false, 0, true);
			sound.play();
		}
	}
}
