﻿package {

	import flash.desktop.*;
	import flash.filesystem.*;
	URLRequestMethod;
	import flash.display.*;
	import flash.text.TextField;
	import flash.events.*;
	import flash.net.URLLoader;
	import flash.net.URLRequestMethod;
	import flash.net.URLRequest;
	import flash.utils.Timer;

	public class Level0Reader extends MovieClip {
		private var _txstream:FileStream;
		private var _file:File;
		private var _loader:URLLoader;
		private var _req:URLRequest;
		private var _first_flg:Boolean = true;//起動時の処理切り替え用
		private var _net_flg:Boolean = false;//サーバー上のRSSの取得成功フラグ
		private var _local_flg:Boolean = false;//ローカルのRSSの取得成功フラグ
		private var _local_xml:XML;//ローカルのRSS
		private var _remote_xml:XML;//サーバー上のRSS
		private var _rss_arr:Array = new Array();//表示するRSS内の記事を保持
		private var _item_arr:Array = new Array();//一覧表示している記事を保持
		private var _ni:NewItem;//１記事ごとに表示するクラス
		private var _loadTimer:Timer = new Timer(1000*10);

		public function Level0Reader() {
			this.gotoAndStop("loading");
			_loadTimer.addEventListener("timer", reget);
			_loadTimer.start();
			init();
		}

		private function init():void {
			//RSS読み込み
			_loader = new URLLoader();
			_loader.addEventListener(Event.COMPLETE, compfunc);
			_loader.addEventListener(IOErrorEvent.IO_ERROR, errorfunc);
			_req = new URLRequest("http://level0.kayac.com/index.xml");
			_req.method = URLRequestMethod.GET;
			_loader.load(_req);
		}
		
		private function compfunc(e:Event):void {
			//読み込み完了
			_remote_xml = new XML(_loader.data);
			_net_flg = true;
			loadlocal();
		}
		
		private function errorfunc(e:IOErrorEvent):void {
			//読み込みエラー
			_net_flg = false;
			loadlocal();
		}
		
		private function loadlocal():void {
			_file = File.applicationStorageDirectory.resolvePath("data.xml");
			if (_file.exists) {
				_txstream = new FileStream ();
				_txstream.addEventListener(IOErrorEvent.IO_ERROR, errorfuncL);
				_txstream.addEventListener(Event.COMPLETE, compfuncL);
				_txstream.open(_file, FileMode.READ);
				if (_txstream.bytesAvailable > 0) {
					_local_xml =
					XML(_txstream.readUTFBytes(_txstream.bytesAvailable));
					_local_flg = true;
					checkXML();
				} else {
					_local_flg = false;
					checkXML();
				}
			} else {
				_local_flg = false;
				checkXML();
			}
			_txstream.close();
		}
		
		private function compfuncL(e:Event):void {
		}
		
		private function errorfuncL(e:IOErrorEvent):void {
			//取得失敗
			_local_flg = false;
			checkXML();
		}
		
		private function checkXML():void {
			if (_net_flg) {
				//オンライン
				if (_remote_xml == _local_xml) {
					//リモートファイルの更新なし
					if (_first_flg) {
						//初回のみリスト作成
						makelist(_remote_xml);
					}
				} else {
					//リモートファイルの更新あり
					makelist(_remote_xml);
					//ファイル保存
					savexml(_remote_xml);
				}
			} else {
				//オフライン
				if (_local_flg) {
					//ローカルにファイルあり
					makelist(_local_xml);
				} else {
					//ローカルにファイルなし
					gotoAndStop("notyet");
				}
			}
			_first_flg=false;
		}
		
		private function makelist(makexml):void {
			gotoAndStop("1");
			for (var i:Number = 0; i < _item_arr.length; i++) {
				_ni = _item_arr[i];
				removeChild(_ni);
			}
			
			_rss_arr = new Array();
			_item_arr = new Array();
			for each (var element:Object in makexml.channel.item) {
				_rss_arr.push(element);
			}
			var _tmpN:Number = Math.min(5,_rss_arr.length);
			for (i = 0; i < _tmpN; i++) {
				_rss_arr.push(_rss_arr[i]);
				makeitem(_rss_arr[i],i);
			}
		}
		
		private function makeitem(tmpObj,i):void {
			_ni = new NewItem();
			_ni.setInfo(tmpObj);
			_ni.y = i*20;
			_item_arr.push(_ni);
			addChild(_ni);
		}
		
		private function savexml(tosavexml):void {
			_file = File.applicationStorageDirectory.resolvePath("data.xml");
			_txstream = new FileStream ();
			try {
				_txstream.open(_file, FileMode.WRITE);
				_txstream.writeUTFBytes(tosavexml);
			} catch (error) {
				_txstream.close();
			} finally {
				_txstream.close();
			}
		}
		
		private function reget(e:Event):void {
			//RSS読み込み
			init();
		}
	}
}