﻿package  {
	
	import flash.display.*;
	import flash.events.*;
	import flash.filesystem.File;
	import flash.desktop.Clipboard;
	import flash.desktop.ClipboardFormats;
	import flash.desktop.NativeDragManager;
	
	public class FileImporter extends EventDispatcher {
		
		private var _targetObj:InteractiveObject;
		private var _fileName:String = "";
		
		public function FileImporter() {
		}
		
		public function init(target:InteractiveObject):void {
			_targetObj = target;
			_targetObj.addEventListener
							(NativeDragEvent.NATIVE_DRAG_ENTER, dragEnterHandler);
			_targetObj.addEventListener
							(NativeDragEvent.NATIVE_DRAG_DROP, dragDropHandler);
		}
		//ドラッグイン
		private function dragEnterHandler(e:NativeDragEvent):void {
			var data:Clipboard = e.clipboard;
			if (data.hasFormat(ClipboardFormats.FILE_LIST_FORMAT)) {
				//_targetObjへのドラッグインを許可
				NativeDragManager.acceptDragDrop(_targetObj);
			}
		}
		//ドラッグドロップ
		private function dragDropHandler(e:NativeDragEvent):void {
			var data:Clipboard = e.clipboard;
			if (data.hasFormat(ClipboardFormats.FILE_LIST_FORMAT)) {
				var file:File = File(e.clipboard.getData
									 				(ClipboardFormats.FILE_LIST_FORMAT)[0]);
				//Flvファイルだったら、イベント発生
				if (checkKind(file.url)) {
					_fileName = file.url;
					dispatchEvent(new Event(Event.COMPLETE));
				}
			}
		}
		//ドラッグしたファイルがFlvファイルかチェック
		private function checkKind(filePath:String):Boolean {
			var res:Boolean = false;
			if (filePath.indexOf(".flv", filePath.length - 4) != -1) {
				res = true;
			}
			return res;
		}
		//ファイルURLのゲッター
		public function get fileName():String {
			return _fileName;
		}
	}
}
