﻿package {
	
	import caurina.transitions.*;
	import flash.display.*;
	import flash.events.*;
	import flash.net.URLRequest;
	import flash.html.HTMLLoader;
	
	public class KuruKuruBrowser extends Sprite{
		
		private var _htmlLdr:HTMLLoader;
		private var _bm:Bitmap;
		private var _bmd:BitmapData;
		private var _spt:Sprite;
		
		public function KuruKuruBrowser() {
			
			// header の動作設定
			_header.addEventListener(MouseEvent.MOUSE_DOWN,
					function(e:Event) {
						stage.nativeWindow.startMove();
					} );
			
			_closeBtn.addEventListener(MouseEvent.CLICK,
					function(e:Event) {
						stage.nativeWindow.close();
					} );
						
			// HTMLLoader の設定
			_htmlLdr = new HTMLLoader();
			_htmlLdr.width = 800;
			_htmlLdr.height = 600;
			_htmlLdr.y = (stage.stageHeight - _htmlLdr.height) / 2;;
			_htmlLdr.x = (stage.stageWidth - _htmlLdr.width) / 2;
			_htmlLdr.addEventListener(Event.LOCATION_CHANGE, changeHandler);
			_htmlLdr.addEventListener(Event.COMPLETE, completeHandler);
			_htmlLdr.load(new URLRequest("http://www.google.com"));
			this.addChild(_htmlLdr);
			
			// レンダリングされたページをキャプチャするための Bitmap の生成
			_bmd = new BitmapData(_htmlLdr.width, _htmlLdr.height, false, 0x0);
			_bm = new Bitmap(_bmd);
			
			//　キャプチャされた画像を 3D 回転させる Sprite
			_spt = new Sprite();
			_spt.addChild(_bm);
			this.addChild(_spt);
			
			// 真ん中で回転させるために中心点をずらす
			_bm.x = - _bm.width / 2;
			_bm.y = - _bm.height / 2;
			_spt.x = this.stage.stageWidth / 2;
			_spt.y = this.stage.stageHeight / 2;
			_spt.rotationX = 90;
		}
		
		// 読み込み開始
		private function changeHandler(e:Event):void {
			_bmd.draw(_htmlLdr);
			Tweener.addTween(_spt,{
								rotationX:-90,
								time:0.5,
								transition:Equations.easeInCubic
								});
			_htmlLdr.visible = false;
			_spt.visible = true;
		}
		
		// 読み込み完了
		private function completeHandler(e:Event):void {
			_spt.rotationX = 90;
			_bmd.draw(_htmlLdr);
			Tweener.addTween(_spt, {
								rotationX:0,
								time:0.5,
								transition:Equations.easeOutCubic,
								onComplete:function() {
									_htmlLdr.visible = true;
									_spt.visible = false;
								}} );
		}
		
	}	
}