﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.filesystem.*;
	import flash.media.*;
	import flash.net.URLRequest;
	import flash.system.System;
	import flash.text.*;
	
	/**
	 * 音声ファイルを表示と読み込み、再生を行うノード
	 */
	public class MusicNode extends Sprite {
		
		private var _sound:Sound;
		private var _file:File;
		public var _title:TextField;
		public var _artist:TextField;
		public var _year:TextField;
		
		public function MusicNode() {
		}
		
		public function init(file:File) {
			_file = file;
			_sound = new Sound();
			_sound.addEventListener(Event.COMPLETE, loadedSound);
			_sound.addEventListener(Event.ID3, loadedID3);
			_sound.load(new URLRequest(_file.nativePath));
		}
		
		private function loadedID3(e:Event):void {
			var id3:ID3Info = _sound.id3;
			_title.text = id3.songName != null ? id3.songName : "";
			_artist.text = id3.artist != null ? id3.artist : "";
			_year.text = id3.year != null ? id3.year : "";
		}
		
		private function loadedSound(e:Event):void {
			var id3:ID3Info = _sound.id3;
			_title.text = _file.name;
			dispatchEvent(e);
		}
		
		public function get sound():Sound { return _sound; }
	}
}
